package slydez;

import java.util.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import java.lang.Object.*;
import java.applet.*;
import javax.swing.JPopupMenu;

import java.awt.event.MouseListener;
import java.awt.event.MouseMotionListener;
import java.awt.event.MouseEvent;



public class LeftPanel extends JPanel implements ActionListener, MouseListener, MouseMotionListener{
    
    public int xpos, ypos; // The X-coordinate and Y-coordinate of the last click
    boolean mouseEntered;
    boolean clicked;
    boolean leftClick, rightClick;    
    
    public LeftPanel() {   
        
        addMouseListener(this);
        addMouseMotionListener(this);               
    }
    
    JPanel leftPanel = new JPanel();
    
        
    //*********Mouse Detection*********
    
    //Invoked when a mouse button has been pressed on a component
    public void mousePressed(MouseEvent e) {
        // Save the coordinates of the click 
        xpos = e.getX(); 
        ypos = e.getY(); 
        
        Cursor newCursor = new Cursor(Cursor.CROSSHAIR_CURSOR);
        setCursor(newCursor);
       
    }
    
    //Invoked when a mouse button has been released on a component
    public void mouseReleased(MouseEvent e) {
        clicked = false;
        Cursor newCursor = new Cursor(Cursor.DEFAULT_CURSOR);
        setCursor(newCursor);    
        
        //Determine which mouse button pressed
        if (e.getButton() == 1) {
            leftClick = true;
        } else if (e.getButton() == 2){
            rightClick = true;
            popupMenu();
        }
    }
     
    //Invoked when the mouse button has been clicked (pressed and released)
    public void mouseClicked(MouseEvent e) {
        clicked = true;
         
    }
    
    //Invoked when the mouse enters a component
    public void mouseEntered(MouseEvent e) {
        mouseEntered = true; 
        Cursor newCursor = new Cursor(Cursor.DEFAULT_CURSOR);
        setCursor(newCursor);
    }
    
    //Invoked when the mouse exits a component
    public void mouseExited(MouseEvent e) {
        mouseEntered = false; 
    }
    
    //Invoked when the mouse is moved
    public void mouseMoved(MouseEvent e) {
        Cursor newCursor = new Cursor(Cursor.DEFAULT_CURSOR);
        setCursor(newCursor);
    }
    
    //Invoked when the mouse is moved while 
    public void mouseDragged(MouseEvent e) {
        Cursor newCursor = new Cursor(Cursor.SE_RESIZE_CURSOR);
        setCursor(newCursor);
       // updateSize(e);
    }    
    
    
    //*******Mouse Features Implemented***********
    
    public void popupMenu(){
        JMenuItem menuItem;
        
        //Create the popup menu.
        JPopupMenu popup = new JPopupMenu();
        menuItem = new JMenuItem("Cut");
        menuItem.addActionListener(this);
        popup.add(menuItem);
        menuItem = new JMenuItem("Copy");
        menuItem.addActionListener(this);
        popup.add(menuItem);menuItem = new JMenuItem("Paste");
        menuItem.addActionListener(this);
        popup.add(menuItem);
        
    }
    
    public void actionPerformed(ActionEvent e) {
      
        String commandName = e.getActionCommand();
        
        if(commandName.equals("Cut")){
            //perform Cut operation
        } else if (commandName.equals("Copy")) {
            //perform Copy operation
        } else if (commandName.equals("Paste")) {
            //perdorm Paste operation
        } 
  }
    
     
        
}