package slydez;
import java.util.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import java.awt.Component;
import java.awt.Container;
import javax.swing.JComponent;
import javax.swing.JMenuBar;
import javax.swing.JMenu;
import javax.swing.JMenuItem;
import javax.swing.JCheckBoxMenuItem;
import javax.swing.JRadioButtonMenuItem;
import javax.swing.ButtonGroup;
import javax.swing.KeyStroke;
import javax.swing.ImageIcon;
import javax.swing.JPanel;
import javax.swing.JTextArea;
import javax.swing.JScrollPane;
import javax.swing.JFrame.*;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.geom.*;
import javax.swing.filechooser.*;
import java.io.File;


public class GUI  extends JFrame implements  ActionListener{
 
    // GLOBAL VARIABLES    
    public JPanel content;
    public JScrollPane scrollPane;
    public JButton button;  
    //set the file name
    String fileName="slide38"; 
    
    
    
    LeftPanel leftPanel = new LeftPanel(); 
    WorkSpace workSpace = new WorkSpace(); 
    
    
    
    
    public GUI(String s) {
        
        super(s);  
        //set the file name in GUI
        workSpace.setCurrentFileName(fileName); 
        
        //Create an instance of the leftPanel workSpace 
        leftPanel.setOpaque(true);
        leftPanel.setBackground(Color.WHITE); //new Color(143, 188, 150));
        leftPanel.setPreferredSize(new Dimension(150, 180));
        //workSpace.setBackground(Color.BLACK);
        workSpace.setPreferredSize(new Dimension(150, 180));
       
        //Creating The Top Menu List (File, Edit, Insert):
        GUImenu TopMenu = new GUImenu();
        setJMenuBar(TopMenu.createMenuBar());
        
        //Creating a JPanel, where Top Toolbar and Bottom Toolbar can be located:
        JPanel MenuPanel = new JPanel(new BorderLayout());
   
           
        //Create a button with an icon for New
        ImageIcon IconNew = new ImageIcon("NewFile.png");
        JButton ButtonNew = new JButton(IconNew);
        ButtonNew.setDisabledIcon(IconNew);
        ButtonNew.setToolTipText("New File");   
        ButtonNew.setActionCommand("New");
        ButtonNew.addActionListener(this);
        
        //Create a button with an icon for Open
        ImageIcon IconOpen = new ImageIcon("OpenFile.png");
        JButton ButtonOpen = new JButton(IconOpen);
        ButtonOpen.setDisabledIcon(IconOpen);
        ButtonOpen.setToolTipText("Open/Update File");  
        ButtonOpen.setActionCommand("Open");
        ButtonOpen.addActionListener(this);
        
        //Create a button with an icon for Save
        ImageIcon IconSave = new ImageIcon("SaveFile.png");
        JButton ButtonSave = new JButton(IconSave);
        ButtonSave.setDisabledIcon(IconSave);
        ButtonSave.setToolTipText("Save File");  
        ButtonSave.setActionCommand("Save");
        ButtonSave.addActionListener(this);
  
 //***********************************************************************************
        
        ImageIcon IconResistor = new ImageIcon("Resistor_Flow_In.jpg");
        JButton ButtonResistor = new JButton(IconResistor);
        ButtonResistor.setDisabledIcon(IconResistor);
        ButtonResistor.setToolTipText("Resistor");  
        ButtonResistor.setActionCommand("Resistor");
        ButtonResistor.addActionListener(this);
        
        ImageIcon IconResistor2 = new ImageIcon("Resistor_Effort_In.jpg");
        JButton ButtonResistor2 = new JButton(IconResistor2);
        ButtonResistor2.setDisabledIcon(IconResistor2);
        ButtonResistor2.setToolTipText("Resistor Effor In");  
        ButtonResistor2.setActionCommand("Resistor Effort In");
        ButtonResistor2.addActionListener(this);
        
        ImageIcon IconInductor = new ImageIcon("Inductor_Effort_In.jpg");
        JButton ButtonInductor = new JButton(IconInductor);
        ButtonInductor.setDisabledIcon(IconInductor);
        ButtonInductor.setToolTipText("Inductor");  
        ButtonInductor.setActionCommand("Inductor");
        ButtonInductor.addActionListener(this);
        
        ImageIcon IconCapacitor = new ImageIcon("Capacitor_Effort_In.jpg");
        JButton ButtonCapacitor = new JButton(IconCapacitor);
        ButtonCapacitor.setDisabledIcon(IconCapacitor);
        ButtonCapacitor.setToolTipText("Capacitor");  
        ButtonCapacitor.setActionCommand("Capacitor");
        ButtonCapacitor.addActionListener(this);

        ImageIcon IconCapacitor2 = new ImageIcon("Capacitor_Flow_In.jpg");
        JButton ButtonCapacitor2 = new JButton(IconCapacitor2);
        ButtonCapacitor2.setDisabledIcon(IconCapacitor);
        ButtonCapacitor2.setToolTipText("Capacitor Flow In");  
        ButtonCapacitor2.setActionCommand("Capacitor Flow In");
        ButtonCapacitor2.addActionListener(this);

        ImageIcon IconSource = new ImageIcon("Source_Effort_Sine_new.jpg");
        JButton ButtonSource = new JButton(IconSource);
        ButtonSource.setDisabledIcon(IconCapacitor);
        ButtonSource.setToolTipText("Source");
        ButtonSource.setActionCommand("Source");
        ButtonSource.addActionListener(this);

        ImageIcon Icon1Junction = new ImageIcon("1_Junction_new.jpg");
        JButton Button1Junction = new JButton(Icon1Junction);
        Button1Junction.setDisabledIcon(IconCapacitor);
        Button1Junction.setToolTipText("1 Junction");
        Button1Junction.setActionCommand("1 Junction");
        Button1Junction.addActionListener(this);

        ImageIcon Icon0Junction = new ImageIcon("0_Junction_new.jpg");
        JButton Button0Junction = new JButton(Icon0Junction);
        Button0Junction.setDisabledIcon(IconCapacitor);
        Button0Junction.setToolTipText("0 Junction");
        Button0Junction.setActionCommand("0 Junction");
        Button0Junction.addActionListener(this);
        
        JToolBar TopToolBar = new JToolBar();
        TopToolBar.add(ButtonNew);
        TopToolBar.add(ButtonOpen); 
        TopToolBar.add(ButtonSave);
        
        TopToolBar.add(ButtonResistor);
        TopToolBar.add(ButtonResistor2);
        
        TopToolBar.add(ButtonCapacitor);
        TopToolBar.add(ButtonCapacitor2);
        TopToolBar.add(Button1Junction);
        TopToolBar.add(ButtonInductor);
        //TopToolBar.add(ButtonSource);
        

        MenuPanel.add(TopToolBar, BorderLayout.NORTH);
        
 
        
       
        //Create a button with an icon for Line
        ImageIcon Icon1 = new ImageIcon("Line.png");
        JButton Button1 = new JButton(Icon1);
        Button1.setDisabledIcon(Icon1);
        Button1.setToolTipText("Line"); 
        //Button1.setEnabled(true);
        //Button.setVerticalTextPosition(AbstractButton.CENTER);
        //Button.setHorizontalTextPosition(AbstractButton.LEFT);
        //Button1.setMnemonic('l');
        Button1.setActionCommand("Line");
        Button1.addActionListener(this);
        
        //Create a button with an icon for Arrow
        ImageIcon Icon2 = new ImageIcon("Arrow.png");
        JButton Button2 = new JButton(Icon2);
        Button2.setDisabledIcon(Icon2);
        Button2.setToolTipText("Arrow");  
        Button2.setActionCommand("Arrow");
        Button2.addActionListener(this);
        
        //Create a button with an icon for Rectangle
        ImageIcon Icon3 = new ImageIcon("Rectangle.png");
        JButton Button3 = new JButton(Icon3);
        Button3.setDisabledIcon(Icon3);
        Button3.setToolTipText("Rectangle");  
        Button3.setActionCommand("Rectangle");
        Button3.addActionListener(this);
        
        //Create a button with an icon for Round Rectangle
        ImageIcon Icon4 = new ImageIcon("RoundRectangle.png");
        JButton Button4 = new JButton(Icon4);
        Button4.setDisabledIcon(Icon4);
        Button4.setToolTipText("Round Rectangle");  
        Button4.setActionCommand("Round Rectangle");
        Button4.addActionListener(this);
        
        //Create a button with an icon for Cirlce
        ImageIcon Icon5 = new ImageIcon("Circle.png");
        JButton Button5 = new JButton(Icon5);
        Button5.setDisabledIcon(Icon5);
        Button5.setToolTipText("Circle");  
        Button5.setActionCommand("Circle");
        Button5.addActionListener(this);
        
        //Create a button with an icon for Ellipse
        ImageIcon Icon6 = new ImageIcon("Ellipse.png");
        JButton Button6 = new JButton(Icon6);
        Button6.setDisabledIcon(Icon6);
        Button6.setToolTipText("Ellipse");  
        Button6.setActionCommand("Ellipse");
        Button6.addActionListener(this);
        
        //Create a button with an icon for Background Color
        ImageIcon Icon7 = new ImageIcon("FillColor.png");
        JButton Button7 = new JButton(Icon7);
        Button7.setDisabledIcon(Icon7);
        Button7.setToolTipText("Fill Color");  
        Button7.setActionCommand("Background Color");
        Button7.addActionListener(this);
        
        //Create a button with an icon for Line Color
        ImageIcon Icon8 = new ImageIcon("LineColor.png");
        JButton Button8 = new JButton(Icon8);
        Button8.setDisabledIcon(Icon8);
        Button8.setToolTipText("Line Colour");  
        Button8.setActionCommand("Line Color");
        Button8.addActionListener(this);
        
        //Create a button with an icon for Line Text Color
        ImageIcon Icon9 = new ImageIcon("TextColor.png");
        JButton Button9 = new JButton(Icon9);
        Button9.setDisabledIcon(Icon9);
        Button9.setToolTipText("Text Colour");  
        Button9.setActionCommand("Text Color");
        Button9.addActionListener(this);
        
        //Create a button with an icon for Text Box
        ImageIcon Icon10 = new ImageIcon("Text.png");
        JButton Button10 = new JButton(Icon10);
        Button10.setDisabledIcon(Icon10);
        Button10.setToolTipText("Text");  
        Button10.setActionCommand("Text Box");
        Button10.addActionListener(this);
        
        //Create a button with an icon for deleting shape
        ImageIcon Icon11 = new ImageIcon("DeleteShape.png");
        JButton Button11 = new JButton(Icon11);
        Button11.setDisabledIcon(Icon11);
        Button11.setToolTipText("Delete Shape");  
        Button11.setActionCommand("Delete Shape");
        Button11.addActionListener(this);
        
       
        JToolBar BottomToolBar = new JToolBar();
        BottomToolBar.add(Button1);
        BottomToolBar.add(Button2); 
        BottomToolBar.add(Button3);
        BottomToolBar.add(Button4);
        BottomToolBar.add(Button5);
        BottomToolBar.add(Button6);
        BottomToolBar.add(Button11);
        BottomToolBar.add(Button10);
        BottomToolBar.add(Button7);   
        BottomToolBar.add(Button8);
        BottomToolBar.add(Button9);
        BottomToolBar.add(ButtonSource);
        BottomToolBar.add(Button0Junction);
        //BottomToolBar.setPreferredSize(new Dimension(100,100));
        MenuPanel.add(BottomToolBar, BorderLayout.SOUTH);
        
       
        
       




 
        //Creating a "split pane" with the two scroll panes in it:
        JSplitPane splitPane = new JSplitPane(JSplitPane.HORIZONTAL_SPLIT, leftPanel, workSpace); 
        splitPane.setOneTouchExpandable(true);
        splitPane.setDividerLocation(150);
         
        //Creating the "Status Bar", where status of the program is displayed to the users.
        JPanel StatusBar = new JPanel(new BorderLayout());
        StatusBar.setOpaque(true);

        //Provide minimum sizes for the two components in the split pane
        Dimension minimumSize = new Dimension(100, 50);
       
        
        JPanel main = new JPanel();
        main.setLayout(new BorderLayout());
        main.add(MenuPanel,BorderLayout.NORTH);
        main.add(splitPane);
        main.add(StatusBar, BorderLayout.SOUTH);  
        add(main);
       
    }


    //Creating the GUI:
    public static void createAndShowGUI() {
     
        //Creating the Main Frame for SLYDES Program
        JFrame MainFrame = new GUI("Electrical Circuit Bond Graph Modeler");
        //MainFrame.setIconImage("Arrow.png"); 
        
        //Setting the minimizing size
        Dimension minimumSize = new Dimension(100, 50);
 
        //Specifying the Main Frame Settings
        MainFrame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        MainFrame.setResizable(true);
        MainFrame.setPreferredSize(new Dimension(1000,750));
        MainFrame.setMinimumSize(minimumSize); 
        MainFrame.pack();
        MainFrame.setVisible(true); 
  }

   
    //When any of the buttons is clicked, this method is invoked
    //and the corresponding action is performed
    public void actionPerformed(ActionEvent e) {
        
        String commandName = e.getActionCommand();
        
        //Create a file chooser
        final JFileChooser fc = new JFileChooser();
        
        if(commandName.equals("New")){
            JOptionPane.showMessageDialog(new JFrame(), "Enter the size here:", "See you", JOptionPane.INFORMATION_MESSAGE);
            System.exit(0);
        } else if (commandName.equals("Open")) {
 

        } else if (commandName.equals("Save")) {
          

        } else if (commandName.equals("Resistor")) {
            workSpace.resistorPressed();
         
        } else if (commandName.equals("Copy")) {
         
        } else if (commandName.equals("Paste")) {
           
        } else if (commandName.equals("Insert")) {
            
        } else if (commandName.equals("New Slide")) {
          
        } else if (commandName.equals("Delete Slide")) {
           
        } else if (commandName.equals("Line")) {    
            workSpace.linePressed();      
            
        } else if (commandName.equals("Arrow")) {   
            workSpace.arrowPressed();
                 
        } else if (commandName.equals("Rectangle")) {             
            workSpace.rectanglePressed();           
            
        } else if (commandName.equals("Round Rectangle")) {            
            workSpace.roundRectanglePressed();           

        } else if (commandName.equals("Circle")) { 
            workSpace.circlePressed();
     
        } else if (commandName.equals("Ellipse")) {   
            workSpace.ellipsePressed();      
            
        } 
        
        else if (commandName.equals("Resistor")){
            workSpace.resistorPressed();  

        }
        
        else if (commandName.equals("Background Color")) {
   
        } else if (commandName.equals("Line/Frame Color")) {

        } else if (commandName.equals("Text Color")) {

        } else if (commandName.equals("Text Box")) {

        } else if (commandName.equals("Delete Shape")){
            if (workSpace.selected){
                int index = workSpace.indexOfSelected(); 
                if (index>=0){

                } else{
                    JOptionPane.showMessageDialog(new JFrame(), "You have not made a selection to delete.", "", JOptionPane.ERROR_MESSAGE);
                }
            }

        }
  }
  
   
  
  public JPanel createContentPanel() {
        //Create the content-pane-to-be.
        JPanel contentPane = new JPanel(new BorderLayout());
        contentPane.setOpaque(true);

        // the container
        content = new JPanel();
        content.setLayout(new BorderLayout());     
     
     
      
        JLabel message = new JLabel("Click on the button");
        content.add(message, BorderLayout.NORTH); 
     
     
        JTextField someText = new JTextField("Type something");
        someText.addActionListener(this);
        content.add(someText, BorderLayout.CENTER);
     
        return content;//Pane;
    } 
       
    
    // Creating the buttons for the a Toolbar
    public JToolBar CreateToolbar(String ButtonNames[]) {
        
        JToolBar toolbar = new JToolBar("Toolbar", JToolBar.HORIZONTAL);
        
        //Creating a generic button to be used 
        //for all the buttons that need to be created:
        JButton button = null;
        
        for (int i=0; i<ButtonNames.length ;i++) {  
            //Creating the button:
            button = new JButton(ButtonNames[i]);
            toolbar.add(button);
            button.addActionListener(this);  
        }
        
        return toolbar;
    }
  
    
    
   public static void main(String[] arg) throws Exception{
     
        javax.swing.SwingUtilities.invokeLater(new Runnable() {
            public void run() {
                createAndShowGUI();
            }
        });     
     
    } 
  

  
  private static void FileButtonClicked (ActionEvent e) {
      // do this....
  }
  
  
  
  
  // This class models an empty slide 
  private class Slide{
      
      private int SlideNumber;
      private boolean TemplateUsed;
      
      //Constructor - Creates/adds a single slide to the file
      private Slide(int Number, boolean IsTemplateUsed){
          SlideNumber=Number+1;
          TemplateUsed = IsTemplateUsed;
      }
      
      public void test(){
          DrawAnObject aCircle=new DrawAnObject();
          
          
      }
          
  }
  
  
  private class DrawAnObject{
      
      public int x_position;
      public int y_position;
      public int diameter;
      public int lineColor;
      public int fillColor;
      public boolean VisibilityStatus;
      public boolean AvailabilityStatus;
      public boolean ObjectSelected;
           
      
      DrawAnObject(){
          VisibilityStatus=true;
          AvailabilityStatus=true;
      }
      
      
  }
  
}
