package slydez;
import java.util.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import java.awt.Component;
import java.awt.Container;
import javax.swing.JComponent;
import javax.swing.JMenuBar;
import javax.swing.JMenu;
import javax.swing.JMenuItem;
import javax.swing.JCheckBoxMenuItem;
import javax.swing.JRadioButtonMenuItem;
import javax.swing.ButtonGroup;
import javax.swing.KeyStroke;
import javax.swing.ImageIcon;
import javax.swing.JPanel;
import javax.swing.JTextArea;
import javax.swing.JScrollPane;
import javax.swing.JFrame;


public class GUImenu {
    
    /** Creates a new instance of GuiMenu */
    public GUImenu() {
    }
    
    public static JMenuBar createMenuBar() {
       
        //Where the GUI is created:
        JMenuBar menuBar = new JMenuBar();
        menuBar.setOpaque(true);
        menuBar.setBackground(Color.WHITE); //new Color(139, 137, 137));
        //menuBar.setPreferredSize(new Dimension(200, 20));
        JMenu menu, submenu;
        JMenuItem menuItem;
        JRadioButtonMenuItem rbMenuItem;
        JCheckBoxMenuItem cbMenuItem;

  

        
        //menuBar.setPreferredSize(new Dimension(200, 20));
        
        //Build FILE Manu
        menu = new JMenu("File");
        menu.setMnemonic(KeyEvent.VK_A);
        menu.getAccessibleContext().setAccessibleDescription("The only menu in this program that has menu items");
        menuBar.add(menu);

        menuItem = new JMenuItem("New...", KeyEvent.VK_T);
        menuItem.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_1, ActionEvent.ALT_MASK));
        menuItem.getAccessibleContext().setAccessibleDescription("Creates a new file.");
        menu.add(menuItem);

        menuItem = new JMenuItem("Open...");  //, new ImageIcon("images/middle.gif"));
        menuItem.setMnemonic(KeyEvent.VK_B);
        menu.add(menuItem);

        menuItem = new JMenuItem("Close..."); //, new ImageIcon("images/middle.gif"));
        menuItem.setMnemonic(KeyEvent.VK_D);
        menu.add(menuItem);

        
        menu.addSeparator();
        
        menuItem = new JMenuItem("Save", KeyEvent.VK_T);
        menuItem.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_1, ActionEvent.ALT_MASK));
        menuItem.getAccessibleContext().setAccessibleDescription("Saves this file.");
        menu.add(menuItem);

        menuItem = new JMenuItem("Save As");  //, new ImageIcon("images/middle.gif"));
        menuItem.setMnemonic(KeyEvent.VK_B);
        menu.add(menuItem);
        
        menu.addSeparator();

        menuItem = new JMenuItem("Print"); //, new ImageIcon("images/middle.gif"));
        menuItem.setMnemonic(KeyEvent.VK_D);
        menu.add(menuItem);
        
        menuItem = new JMenuItem("Print Preview"); //, new ImageIcon("images/middle.gif"));
        menuItem.setMnemonic(KeyEvent.VK_D);
        menu.add(menuItem);
        
        menu.addSeparator();
        
        menuItem = new JMenuItem("Page Properties"); //, new ImageIcon("images/middle.gif"));
        menuItem.setMnemonic(KeyEvent.VK_D);
        menu.add(menuItem);
        
        menu.addSeparator();
        
        menuItem = new JMenuItem("Exit"); //, new ImageIcon("images/middle.gif"));
        menuItem.setMnemonic(KeyEvent.VK_D);
        menu.add(menuItem);
        
               
        //Build EDIT Menu.
        menu = new JMenu("Edit");
        menu.setMnemonic(KeyEvent.VK_A);
        menuBar.add(menu);

        menuItem = new JMenuItem("Undo");
        menuItem.setMnemonic(KeyEvent.VK_D);
        menu.add(menuItem);
        
        menuItem = new JMenuItem("Redo");
        menuItem.setMnemonic(KeyEvent.VK_D);
        menu.add(menuItem);
        
        menu.addSeparator();
        
        menuItem = new JMenuItem("Cut");
        menuItem.setMnemonic(KeyEvent.VK_D);
        menu.add(menuItem);
        
        menuItem = new JMenuItem("Copy");
        menuItem.setMnemonic(KeyEvent.VK_D);
        menu.add(menuItem);
        
        menuItem = new JMenuItem("Paste");
        menuItem.setMnemonic(KeyEvent.VK_D);
        menu.add(menuItem);
        
        menu.addSeparator();
        
        menuItem = new JMenuItem("Select All");
        menuItem.setMnemonic(KeyEvent.VK_D);
        menu.add(menuItem);
        
        
        //Build INSERT Menu.
        menu = new JMenu("Insert");
        menu.setMnemonic(KeyEvent.VK_A);
        menuBar.add(menu);

        menuItem = new JMenuItem("New Slide");
        menuItem.setMnemonic(KeyEvent.VK_D);
        menu.add(menuItem);
        
        menuItem = new JMenuItem("Dupliacte Slide");
        menuItem.setMnemonic(KeyEvent.VK_D);
        menu.add(menuItem);
        
        menu.addSeparator();
        
        menuItem = new JMenuItem("Pictures");
        menuItem.setMnemonic(KeyEvent.VK_D);
        menu.add(menuItem);
        
        menuItem = new JMenuItem("Table");
        menuItem.setMnemonic(KeyEvent.VK_D);
        menu.add(menuItem);
       
        
        return menuBar;
        
        }
    

  
    
}
